'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteTheme = exports.storeTheme = exports.changeTheme = undefined;

var _constants = require('./constants');

/**
 * Used to change the theme
 * @param theme
 * theme are identified with a key '_name'
 * OR it can be the name of theme stored in themes
 */
var changeTheme = exports.changeTheme = function changeTheme(theme) {
  return {
    type: _constants.CHANGE_THEME,
    theme: theme
  };
};

/**
 * Add a new themes to the redux themes
 * theme are identified with a key '_name'
 * @param theme
 */
var storeTheme = exports.storeTheme = function storeTheme(theme) {
  return {
    type: _constants.STORE_THEME,
    theme: theme
  };
};

/**
 * Remove an existing theme to the redux themes
 * theme are identified with a key '_name'
 * @param theme
 */
var deleteTheme = exports.deleteTheme = function deleteTheme(theme) {
  return {
    type: _constants.DELETE_THEME,
    theme: theme
  };
};