'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reselect = require('reselect');

var _reactRedux = require('react-redux');

var _BootstrapProvider = require('bootstrap-styled/lib/BootstrapProvider');

var _BootstrapProvider2 = _interopRequireDefault(_BootstrapProvider);

var _selectors = require('../../selectors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ConnectedBootstrapProvider = function ConnectedBootstrapProvider(props) {
  return _react2.default.createElement(_BootstrapProvider2.default, props);
};

/** We map the theme from redux */
var mapStateToProps = (0, _reselect.createStructuredSelector)({
  theme: _selectors.selectTheme
});

var withConnect = (0, _reactRedux.connect)(mapStateToProps);

exports.default = (0, _redux.compose)(withConnect)(ConnectedBootstrapProvider);
module.exports = exports['default'];