'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapDispatchToProps = exports.ThemeToggle = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _Toggle = require('bootstrap-styled-toggle/lib/components/Toggle');

var _Toggle2 = _interopRequireDefault(_Toggle);

var _reselect = require('reselect');

var _actions = require('../../actions');

var _selectors = require('../../selectors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ThemeToggle is used to display a select option to change theme
 * @param value
 * @param values
 * @param onThemeToggle
 * @param className
 * @constructor
 */
var ThemeToggle = exports.ThemeToggle = function ThemeToggle(_ref) {
  var value = _ref.value,
      values = _ref.values,
      onThemeToggle = _ref.onThemeToggle,
      className = _ref.className;
  return _react2.default.createElement(_Toggle2.default, { value: value, values: values, onToggle: onThemeToggle, className: className });
};

ThemeToggle.defaultProps = {
  className: null
};

ThemeToggle.propTypes = {
  onThemeToggle: _propTypes2.default.func.isRequired,
  value: _propTypes2.default.string.isRequired,
  values: _propTypes2.default.array.isRequired,
  className: _propTypes2.default.string
};

var mapStateToProps = (0, _reselect.createStructuredSelector)({
  value: _selectors.selectValue,
  values: _selectors.selectValues
});

var mapDispatchToProps = exports.mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    onThemeToggle: function onThemeToggle(evt) {
      return dispatch((0, _actions.changeTheme)(evt.target.value));
    }
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(ThemeToggle);