'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _bootstrapStyled = require('bootstrap-styled');

var _themeReducer = require('../themeReducer');

var _themeReducer2 = _interopRequireDefault(_themeReducer);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

describe('themeReducer', function () {
  var state = void 0;
  var theme = void 0;
  var themes = void 0;
  var expectedResult = void 0;
  beforeEach(function () {
    theme = {
      _name: 'test_theme',
      '$color-primary': 'red'
    };
    themes = _defineProperty({
      'bootstrap-styled': _bootstrapStyled.theme
    }, theme._name, theme);
    state = _themeReducer.initialState;
    expectedResult = undefined;
    // we force reinstall bootstrap in store just in case we delete it
    (0, _themeReducer2.default)(state, (0, _actions.storeTheme)(_bootstrapStyled.theme));
  });

  it('should return the initial state', function () {
    expectedResult = state;
    expect((0, _themeReducer2.default)(undefined, {})).toEqual(expectedResult);
  });

  it('should handle the changeTheme action correctly using a theme', function () {
    expectedResult = {
      theme: theme,
      themes: themes
    };
    expect((0, _themeReducer2.default)(_extends({}, state, { themes: _defineProperty({ 'bootstrap-styled': _bootstrapStyled.theme }, theme._name, theme) }), (0, _actions.changeTheme)(theme))).toEqual(expectedResult); // eslint-disable-line no-underscore-dangle
  });

  it('should handle the changeTheme action correctly using a name', function () {
    expectedResult = {
      theme: theme,
      themes: themes
    };
    expect((0, _themeReducer2.default)(_extends({}, state, { themes: _defineProperty({ 'bootstrap-styled': _bootstrapStyled.theme }, theme._name, theme) }), (0, _actions.changeTheme)(theme._name))).toEqual(expectedResult); // eslint-disable-line no-underscore-dangle
  });

  it('should handle the deleteTheme action correctly', function () {
    expectedResult = {
      theme: _bootstrapStyled.theme,
      themes: {}
    };
    expect((0, _themeReducer2.default)(state, (0, _actions.deleteTheme)(_bootstrapStyled.theme))).toEqual(expectedResult);
  });

  it('should handle the storeTheme action correctly', function () {
    expectedResult = {
      theme: _bootstrapStyled.theme,
      themes: _defineProperty({}, theme._name, theme)
    };
    expect((0, _themeReducer2.default)(state, (0, _actions.storeTheme)(theme))).toEqual(expectedResult);
  });
});