'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initialState = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _theme = require('bootstrap-styled/lib/theme');

var _theme2 = _interopRequireDefault(_theme);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = exports.initialState = {
  theme: _theme2.default,
  themes: { 'bootstrap-styled': _theme2.default }
};

/* eslint-disable no-underscore-dangle */
/**
 * themeReducer
 * @param state
 * @param action
 * @returns {*}
 */

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case _constants.CHANGE_THEME:
      {
        // allow change by theme name
        if (typeof action.theme === 'string') {
          return { themes: state.themes, theme: state.themes[action.theme] };
        }
        // allow change by insert/override themes directly
        return { themes: _extends({}, state.themes, _defineProperty({}, action.theme._name, action.theme)), theme: action.theme };
      }
    case _constants.STORE_THEME:
      {
        return { themes: _extends({}, state.themes, _defineProperty({}, action.theme._name, action.theme)), theme: state.theme };
      }
    case _constants.DELETE_THEME:
      {
        var newState = _extends({}, state);
        delete newState.themes[action.theme._name];
        return newState;
      }
    default:
      return state;
  }
};