'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.selectValues = exports.selectValue = exports.selectTheme = exports.selectThemes = exports.selectBsRedux = undefined;

var _reselect = require('reselect');

var selectBsRedux = exports.selectBsRedux = function selectBsRedux(state) {
  return state['bs.redux'];
};

/**
 * themes
 */
var selectThemes = exports.selectThemes = (0, _reselect.createSelector)(selectBsRedux, function (bsReduxState) {
  return bsReduxState.themes;
});

/**
 * theme
 */
var selectTheme = exports.selectTheme = (0, _reselect.createSelector)(selectBsRedux, function (bsReduxState) {
  return bsReduxState.theme;
});

/**
 * current theme name
 */
var selectValue = exports.selectValue = (0, _reselect.createSelector)(selectBsRedux, function (bsReduxState) {
  return bsReduxState.theme._name;
} // eslint-disable-line no-underscore-dangle
);

/**
 * current available theme list
 */
var selectValues = exports.selectValues = (0, _reselect.createSelector)(selectBsRedux, function (bsReduxState) {
  return Object.keys(bsReduxState.themes).map(function (key) {
    return bsReduxState.themes[key]._name;
  });
} // eslint-disable-line no-underscore-dangle
);