'use strict';

var _bootstrapStyled = require('bootstrap-styled');

var _actions = require('../actions');

var _constants = require('../constants');

describe('bootstrap-styled-redux actions', function () {
  var theme = void 0;
  beforeAll(function () {
    theme = (0, _bootstrapStyled.makeTheme)({
      '$brand-primary': 'red'
    });
  });

  describe('changeTheme', function () {
    it('should dispatch changeTheme', function () {
      expect((0, _actions.changeTheme)(theme)).toEqual({
        type: _constants.CHANGE_THEME,
        theme: theme
      });
    });
  });

  describe('storeTheme', function () {
    it('should dispatch storeTheme', function () {
      expect((0, _actions.storeTheme)(theme)).toEqual({
        type: _constants.STORE_THEME,
        theme: theme
      });
    });
  });

  describe('deleteTheme', function () {
    it('should dispatch deleteTheme', function () {
      expect((0, _actions.deleteTheme)(theme)).toEqual({
        type: _constants.DELETE_THEME,
        theme: theme
      });
    });
  });
});